// BHOCOP Version 1.0
// Copyright (c) 2001 Ziff Davis Media, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, May 22, 2001.
// Programmer: Patrick Philippot

#include "stdafx.h"

#include <atlbase.h>

#include "BHOCop.h"
#include "BHOCopDlg.h"
#include "StringExt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const PTCHAR szMutex = _T("BHOCop_Mutex");

#pragma data_seg( "BHOCop_Shared" )
HWND	g_hMainWindow = NULL;
#pragma data_seg()

/////////////////////////////////////////////////////////////////////////////
// CBHOCopApp

BEGIN_MESSAGE_MAP(CBHOCopApp, CWinApp)
	//{{AFX_MSG_MAP(CBHOCopApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBHOCopApp construction

CBHOCopApp::CBHOCopApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBHOCopApp object

CBHOCopApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBHOCopApp initialization

BOOL CBHOCopApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// A mutex is used to prevent multiple instances of FWConf
	if ((m_hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, szMutex)) != NULL)
	{
		// FWConf already running
		CloseHandle(m_hMutex);
		m_hMutex = NULL;
		::SetForegroundWindow(g_hMainWindow);
		return(FALSE);
	}
	else
		m_hMutex = CreateMutex(NULL, TRUE, szMutex);


	// Check if user has enough rights to write to HKLM
	CRegKey BHOKey;

	if (BHOKey.Create(HKEY_LOCAL_MACHINE, CBHOCopDlg::g_szBHOKey) != ERROR_SUCCESS)
	{
		AfxMessageBox(IDS_EXIT_NOT_ENOUGH_RIGHTS, MB_OK | MB_ICONSTOP, 0);
		m_bCanAccess = FALSE;
	}
	else 
	{
		m_bCanAccess = TRUE;
		BHOKey.Close();
	}

	CStringEx sCmdLine = GetCommandLine();

	BOOL bQuiet = sCmdLine.FindNoCase(_T("/q")) != -1;

	CBHOCopDlg dlg;

	dlg.m_bQuiet = bQuiet;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
