// BHOCOP Version 1.0
// Copyright (c) 2001 Ziff Davis Media, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, May 22, 2001.
// Programmer: Patrick Philippot

#include "stdafx.h"

#include <AtlBase.h>
#include <tchar.h>

#include "RegKeyEx.h"
#include "BHOCop.h"
#include "BHOCopDlg.h"
#include "SaveConfigDlg.h"
#include "LoadConfigDlg.h"
#include "CVersion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

TCHAR CBHOCopDlg::g_szFullBHOKey[] = _T("[HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Browser Helper Objects");
TCHAR CBHOCopDlg::g_szBHOKey[] = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Browser Helper Objects\\");
TCHAR CBHOCopDlg::g_szIniName[] = _T("BhoCop.ini");
TCHAR CBHOCopDlg::g_szRescueName[] = _T("rescue.reg");
TCHAR CBHOCopDlg::g_szIniDisabledSection[] = _T("disabled");
TCHAR CBHOCopDlg::g_szIniOptSection[] = _T("options");
TCHAR CBHOCopDlg::g_szIniCfgSection[] = _T("configs");
TCHAR CBHOCopDlg::g_szDefaultConfName[] = _T("default");
TCHAR CBHOCopDlg::g_szLastConf[] = _T("LastConf");
TCHAR CBHOCopDlg::g_szCLSID[] = _T("CLSID\\");
TCHAR CBHOCopDlg::g_szAppId[] = _T("AppId\\");
TCHAR CBHOCopDlg::g_szTrue[] = _T("1");
TCHAR CBHOCopDlg::g_szFalse[] = _T("0");
TCHAR CBHOCopDlg::g_szUnknown[] = _T("Unknown");
TCHAR CBHOCopDlg::g_szLocationKey[] = _T("\\InprocServer32");
TCHAR CBHOCopDlg::g_szTreatAs[] = _T("\\TreatAs");
TCHAR CBHOCopDlg::g_szRescueDone[] = _T("rescuefilecreated");
TCHAR CBHOCopDlg::g_szPosSection[] = _T("wndpos");
TCHAR CBHOCopDlg::g_szShowEntry[] = _T("show");
TCHAR CBHOCopDlg::g_szFlagsEntry[] = _T("flags");
TCHAR CBHOCopDlg::g_szLeftEntry[] = _T("left");
TCHAR CBHOCopDlg::g_szRightEntry[] = _T("right");
TCHAR CBHOCopDlg::g_szTopEntry[] = _T("top");
TCHAR CBHOCopDlg::g_szBottomEntry[] = _T("bottom");
TCHAR CBHOCopDlg::g_szColumn0[] = _T("column0");
TCHAR CBHOCopDlg::g_szColumn1[] = _T("column1");
TCHAR CBHOCopDlg::g_szColumn2[] = _T("column2");
TCHAR CBHOCopDlg::g_szColumn3[] = _T("column3");
TCHAR CBHOCopDlg::g_szColumn4[] = _T("column4");
TCHAR CBHOCopDlg::g_szWduKey[] = _T("SOFTWARE\\Classes\\CLSID\\{AEB6717E-7E19-11d0-97EE-00C04FD91972}\\InProcserver32");
TCHAR CBHOCopDlg::g_szActiveDesktopKey[] = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer");
TCHAR CBHOCopDlg::g_szShellState[] = _T("ShellState");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBHOCopDlg dialog

CBHOCopDlg::CBHOCopDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBHOCopDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBHOCopDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bChanged = FALSE;
	m_bSizeInit = FALSE;
	m_nLastSel = -1;
	m_bQuiet = FALSE;
}

void CBHOCopDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBHOCopDlg)
	DDX_Control(pDX, IDC_BHOLIST, m_lstBHO);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBHOCopDlg, CDialog)
	//{{AFX_MSG_MAP(CBHOCopDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_WM_DESTROY()
	ON_COMMAND(ID_FILE_SAVECFGAS, OnFileSaveCfgAs)
	ON_COMMAND(ID_FILE_LOADCFG, OnFileLoadCfg)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_ITEM_ENABLE, OnItemEnable)
	ON_COMMAND(ID_ITEM_REMOVE, OnItemRemove)
	ON_UPDATE_COMMAND_UI(ID_ITEM_ENABLE, OnUpdateItemEnable)
	ON_UPDATE_COMMAND_UI(ID_ITEM_REMOVE, OnUpdateItemRemove)
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_FILE_LOADCFG, OnUpdateFileLoadCfg)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVECFGAS, OnUpdateFileSaveCfgAs)
	ON_NOTIFY(NM_DBLCLK, IDC_BHOLIST, OnDblclkBhoList)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_BHOLIST, OnClickBhoList)
	ON_WM_ERASEBKGND()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
	ON_WM_INITMENUPOPUP()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBHOCopDlg message handlers

void CBHOCopDlg::OnInitMenuPopup(CMenu *pPopupMenu, UINT nIndex,BOOL bSysMenu)
{
	// MSDN code - used to enable processing of UPDATE_COMMAND_UI
	// in a dialog box based application.
    ASSERT(pPopupMenu != NULL);

    // Check the enabled state of various menu items.
    CCmdUI state;
    state.m_pMenu = pPopupMenu;
    ASSERT(state.m_pOther == NULL);
    ASSERT(state.m_pParentMenu == NULL);

    // Determine if menu is popup in top-level menu and set m_pOther to
    // it if so (m_pParentMenu == NULL indicates that it is secondary popup).
    HMENU hParentMenu;
    if (AfxGetThreadState()->m_hTrackingMenu == pPopupMenu->m_hMenu)
        state.m_pParentMenu = pPopupMenu;    // Parent == child for tracking popup.
    else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL)
    {
        CWnd* pParent = this;
		// Child windows don't have menus--need to go to the top!
        if (pParent != NULL &&  (hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL)
        {
			int nIndexMax = ::GetMenuItemCount(hParentMenu);
			for (int nIndex = 0; nIndex < nIndexMax; nIndex++)
			{
				if (::GetSubMenu(hParentMenu, nIndex) == pPopupMenu->m_hMenu)
				{
					// When popup is found, m_pParentMenu is containing menu.
					state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
					break;
				}
			}
		}
	}

    state.m_nIndexMax = pPopupMenu->GetMenuItemCount();
    for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax; state.m_nIndex++)
    {
		state.m_nID = pPopupMenu->GetMenuItemID(state.m_nIndex);
		if (state.m_nID == 0)
			continue; // Menu separator or invalid cmd - ignore it.

		ASSERT(state.m_pOther == NULL);
		ASSERT(state.m_pMenu != NULL);
		if (state.m_nID == (UINT)-1)
		{
			// Possibly a popup menu, route to first item of that popup.
			state.m_pSubMenu = pPopupMenu->GetSubMenu(state.m_nIndex);
			if (state.m_pSubMenu == NULL ||
			(state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 || state.m_nID == (UINT)-1)
			{
				continue;       // First item of popup can't be routed to.
			}
			state.DoUpdate(this, TRUE);   // Popups are never auto disabled.
		}
		else
		{
			// Normal menu item.
			// Auto enable/disable if frame window has m_bAutoMenuEnable
			// set and command is _not_ a system command.
			state.m_pSubMenu = NULL;
			state.DoUpdate(this, FALSE);
		}

		// Adjust for menu deletions and additions.
		UINT nCount = pPopupMenu->GetMenuItemCount();
		if (nCount < state.m_nIndexMax)
		{
			state.m_nIndex -= (state.m_nIndexMax - nCount);
			while (state.m_nIndex < nCount &&
			pPopupMenu->GetMenuItemID(state.m_nIndex) == state.m_nID)
			{
				state.m_nIndex++;
			}
		}
		state.m_nIndexMax = nCount;
    }
} 

BOOL CBHOCopDlg::OnInitDialog()
{
	StoreOsVersion();
	// Get application path
	GetModuleFileName(AfxGetApp()->m_hInstance, m_sIniFilename.GetBuffer(MAX_PATH + 1), MAX_PATH + 1);
	m_sIniFilename.ReleaseBuffer();
	m_sIniFilename.StripToPath();
	m_sRescueFilename = m_sIniFilename;
	m_sIniFilename += g_szIniName;
	m_sRescueFilename += g_szRescueName;

	if (!m_bQuiet)
	{
		// Store initial layout data for resizing
		CRect	rectDialog;
		CRect	rectBHOList;
		CRect	rectConfLabel;
		CRect	rectExit;
		CRect	rectHelp;

		CWnd*	pwndBHOList = GetDlgItem(IDC_BHOLIST);
		CWnd*	pwndConfLabel = GetDlgItem(IDC_CONF_LABEL);
		CWnd*	pwndExit = GetDlgItem(IDOK);
		CWnd*	pwndHelp = GetDlgItem(ID_HELP);

		GetClientRect(rectDialog);
		ClientToScreen(&rectDialog);

		pwndBHOList->GetWindowRect(rectBHOList);
		pwndConfLabel->GetWindowRect(rectConfLabel);
		pwndExit->GetWindowRect(rectExit);
		pwndHelp->GetWindowRect(rectHelp);

		m_nRightOffsetExit = rectDialog.right - rectExit.left;
		m_nRightOffsetHelp = rectDialog.right - rectHelp.left;
		m_nBottomOffsetExit = rectDialog.bottom - rectExit.top;
		m_nBottomOffsetConf = rectDialog.bottom - rectConfLabel.top;

		m_nListOffsetH = rectDialog.right - rectBHOList.right;
		m_nListOffsetV = rectDialog.bottom - rectBHOList.bottom;
		m_bSizeInit = TRUE;

		// Restore window position and state
		int nFlags;
 		int	nShow;
 		CRect rect;
 
 		if (((nShow = GetPrivateProfileInt(g_szPosSection, g_szShowEntry, -1, m_sIniFilename)) != -1)
 			&& 
 			((rect.top = GetPrivateProfileInt(g_szPosSection, g_szTopEntry, -1, m_sIniFilename)) != -1)
 			&&
 			((rect.left = GetPrivateProfileInt(g_szPosSection, g_szLeftEntry, -1, m_sIniFilename)) != -1)
 			&&
 			((rect.bottom = GetPrivateProfileInt(g_szPosSection, g_szBottomEntry, -1, m_sIniFilename)) != -1)
 			&&
 			((rect.right = GetPrivateProfileInt(g_szPosSection, g_szRightEntry, -1, m_sIniFilename)) != -1)) 
 		
 		{
 			WINDOWPLACEMENT WndStatus;
 
 			nFlags = GetPrivateProfileInt(g_szPosSection, g_szFlagsEntry, 0, m_sIniFilename);
 			WndStatus.flags = nFlags;
 			WndStatus.rcNormalPosition = rect;
 			WndStatus.showCmd = nShow;
 			WndStatus.ptMinPosition = CPoint(0,0);
 			WndStatus.ptMaxPosition = CPoint(-GetSystemMetrics(SM_CXBORDER), -GetSystemMetrics(SM_CYBORDER));
 
 			SetWindowPlacement(&WndStatus);
  		}
	}

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Allow full row selection
	m_lstBHO.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// Check registry access
	m_bCanAccess = ((CBHOCopApp*) AfxGetApp())->m_bCanAccess;

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Create image list associated with list view
	m_imgState.Create(16, 16, ILC_COLOR8 | ILC_MASK, 4, 1);
	AddStateIcon(IDI_ENABLED);
	AddStateIcon(IDI_DISABLED);
	AddStateIcon(IDI_BADINSTALL);
	AddStateIcon(IDI_BROKEN);
	m_lstBHO.SetImageList(&m_imgState, LVSIL_SMALL);

	// Retrieve column width
	int nWidth = GetPrivateProfileInt(g_szPosSection, g_szColumn0, 140, m_sIniFilename);
	m_lstBHO.InsertColumn(0, _T("BHO Name"), LVCFMT_LEFT, nWidth);
	nWidth = GetPrivateProfileInt(g_szPosSection, g_szColumn1, 180, m_sIniFilename);
	m_lstBHO.InsertColumn(1, _T("Information"), LVCFMT_LEFT, nWidth);
	nWidth = GetPrivateProfileInt(g_szPosSection, g_szColumn2, 60, m_sIniFilename);
	m_lstBHO.InsertColumn(2, _T("Version"), LVCFMT_LEFT, nWidth);
	nWidth = GetPrivateProfileInt(g_szPosSection, g_szColumn3, 250, m_sIniFilename);
	m_lstBHO.InsertColumn(3, _T("Path"), LVCFMT_LEFT, nWidth);
	nWidth = GetPrivateProfileInt(g_szPosSection, g_szColumn4, 250, m_sIniFilename);
	m_lstBHO.InsertColumn(4, _T("BHO Identifier"), LVCFMT_LEFT, nWidth);

	// Retrieve last configuration name
	GetPrivateProfileString(g_szIniOptSection, 
							g_szLastConf, 
							_T("default"), 
							m_sLastConf.GetBuffer(MAX_CONFNAME_LEN), 
							MAX_CONFNAME_LEN, 
							m_sIniFilename);
	m_sLastConf.ReleaseBuffer();
	GetDlgItem(IDC_CONFIGNAME)->SetWindowText(m_sLastConf);

	EnumBHOs();

	if (m_bQuiet)
		OnCancel();		

	return TRUE;  // return TRUE  unless you set the focus to a control
}

int CBHOCopDlg::AddStateIcon(int nId)
{
	// Helper adding state icons to image list
	HICON	hIcon;
	int		nIndex;

	hIcon = (HICON) LoadImage(AfxGetInstanceHandle(),
							  MAKEINTRESOURCE(nId),
							  IMAGE_ICON,
							  16, 16, NULL);
	nIndex = m_imgState.Add(hIcon);
	DestroyIcon(hIcon);

	return nIndex;
}

void CBHOCopDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBHOCopDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBHOCopDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBHOCopDlg::OnAppAbout() 
{
	CAboutDlg dlg;

	dlg.DoModal();	
}

void CBHOCopDlg::EnumBHOs()
{
	CRegKeyEx	BHOKey;
	CStdioFile	rescuefile;
	BOOL		bCanCreateRescue;

	if (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) != ERROR_SUCCESS)
		return;

	// Clear list
	m_lstBHO.DeleteAllItems();

	// Prepare rescue file
	if (bCanCreateRescue = rescuefile.Open(m_sRescueFilename, CFile::modeCreate | CFile::modeWrite))
	{
		rescuefile.WriteString(_T("REGEDIT4\n\n"));
		rescuefile.WriteString(g_szFullBHOKey);
		rescuefile.WriteString(_T("]\n\n"));
	}

	DWORD	dwIndex = 0;
	TCHAR	szClsidKey[MAX_PATH+1];
	TCHAR	szBHOName[MAX_PATH + 1];

	// Clear list of items waiting to be removed
	m_ToBeDeleted.RemoveAll();

	// For each BHO key...
	while (BHOKey.EnumKey(dwIndex, szClsidKey, MAX_PATH + 1) != ERROR_NO_MORE_ITEMS)
	{
		CString sBHOSubKey;
		CRegKey	BHOSubKey;
		DWORD	dwLen = MAX_PATH + 1;

		sBHOSubKey = g_szBHOKey ;
		sBHOSubKey += szClsidKey;

		if (BHOSubKey.Open(HKEY_LOCAL_MACHINE, sBHOSubKey, KEY_READ) == ERROR_SUCCESS)
		{
			if (BHOSubKey.QueryValue(szBHOName, NULL, &dwLen) != ERROR_SUCCESS)
				szBHOName[0] = TCHAR('\0');
			if (szBHOName[0] == TCHAR('\0')) // May be empty anyway
			{
				CRegKey AppIdKey;
				CString	sAppIdKey = g_szAppId;
				sAppIdKey += szClsidKey;
		
				if (AppIdKey.Open(HKEY_CLASSES_ROOT, sAppIdKey, KEY_READ) == ERROR_SUCCESS)
				{
					if (AppIdKey.QueryValue(szBHOName, NULL, &dwLen) != ERROR_SUCCESS)
							szBHOName[0] = TCHAR('\0');

					AppIdKey.Close();
				}
			}

			AddBHOToList(szClsidKey, szBHOName, TRUE); 
			// BHO is considered enabled unless CheckBHO fails.

			if (bCanCreateRescue)
			{
				rescuefile.WriteString(g_szFullBHOKey);
				rescuefile.WriteString(_T("\\"));
				rescuefile.WriteString(szClsidKey);
				rescuefile.WriteString(_T("]\n@=\""));
				rescuefile.WriteString(szBHOName);
				rescuefile.WriteString(_T("\"\n\n"));
			}

			BHOSubKey.Close();
		}

		dwIndex++;
	}

	BHOKey.Close();

	// Now enumerate disabled BHOs from the [disabled] section of bhocop.ini
	TCHAR szBuffer[2048];

	// Get list of entries
	GetPrivateProfileString(g_szIniDisabledSection, NULL, _T(""), szBuffer, sizeof(szBuffer), m_sIniFilename);
	
	TCHAR	szClsid[MAX_CLSID_LEN];
	TCHAR*	lpClsid = szBuffer;

	// For each entry, get BHO name and add entry to listbox
	while (*lpClsid != (TCHAR) '\0')
	{
		_tcscpy(szClsid, lpClsid);
		lpClsid += _tcslen(szClsid) + 1;

		GetPrivateProfileString(g_szIniDisabledSection, szClsid, _T(""), szBHOName, sizeof(szBHOName), m_sIniFilename);
		AddBHOToList(szClsid, szBHOName, FALSE);
		// BHO is considered disabled unless it no longer exists.

		if (bCanCreateRescue)
		{
			rescuefile.WriteString(g_szFullBHOKey);
			rescuefile.WriteString(_T("\\"));
			rescuefile.WriteString(szClsid);
			rescuefile.WriteString(_T("]\n@=\""));
			rescuefile.WriteString(szBHOName);
			rescuefile.WriteString(_T("\"\n\n"));
		}
	}

	if (bCanCreateRescue)
	{
		rescuefile.WriteString(_T("\n"));
		rescuefile.Close();
		
		BOOL bRescueRescueFile = GetPrivateProfileInt(g_szIniOptSection, g_szRescueDone, 0, m_sIniFilename) == 0;
		if (bRescueRescueFile)
		{
			CStringEx sNewName = m_sRescueFilename;

			sNewName.ReplaceNameComponent(CString(_T("bak")), EX_STRING_REPEXT);
			::CopyFile(m_sRescueFilename, sNewName, TRUE);
			::SetFileAttributes(sNewName, FILE_ATTRIBUTE_READONLY);
			WritePrivateProfileString(g_szIniOptSection, g_szRescueDone, _T("1"), m_sIniFilename);
		}
	}

	// Cleanup incorrect entries
	int nCount = m_ToBeDeleted.GetSize();
	for (int nIndex = 0; nIndex < nCount; nIndex++)
	{
		CRegKeyEx	BHOKey;

		if (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS)
		{
			BHOKey.RecurseDeleteKey(m_ToBeDeleted.GetAt(nIndex));
			BHOKey.Close();
		}
	}

	if (m_nLastSel != -1)
	{
		m_lstBHO.SetItemState(m_nLastSel, LVIS_SELECTED, LVIS_SELECTED);
		m_nLastSel = -1;
	}
}

void CBHOCopDlg::AddBHOToList(LPCTSTR lpszCLSID, LPSTR lpszBHOName, BOOL bEnabled)
{
	// Check CLSID
	CStringEx	sBHOObjectName;
	CStringEx	sInfo;
	CStringEx	sVersion;
	CStringEx	sPath;
	
	BHO_CHECK_CODE	nCheckCode = CheckBHO(lpszCLSID, sBHOObjectName, sInfo, sVersion, sPath);

	if (lpszBHOName[0] == TCHAR('\0'))
		_tcscpy(lpszBHOName, sBHOObjectName);
	if (lpszBHOName[0] == TCHAR('\0'))
		_tcscpy(lpszBHOName, g_szUnknown);

	if (bEnabled)
	{
		// If CLSID is found in the [disabled] section when enumerating the active BHOs, 
		// then the BHO has certainly been re-activated by some external code. We 
		// can safely delete the key since it can be restored by BHO Cop.
		TCHAR	szBHOName[MAX_PATH + 1];

		GetPrivateProfileString(g_szIniDisabledSection, lpszCLSID, _T(""), szBHOName, sizeof(szBHOName), m_sIniFilename);
		if (szBHOName[0] != _T('\0'))
		{
			// Register incorrect entry for deletion
			m_ToBeDeleted.Add(lpszCLSID);
			return;
		}
	}

	int nIndex;

	BHO_STATE_CODE nStateCode;

	if (nCheckCode != BHO_CHECK_OK)
	{
		nStateCode = nCheckCode == BHO_CHECK_BROKEN? BHO_STATE_BROKEN : BHO_STATE_WARNING;
		nIndex = m_lstBHO.InsertItem(0, lpszBHOName, nStateCode);
	}
	else
	{
		nStateCode = bEnabled? BHO_STATE_ENABLED : BHO_STATE_DISABLED;
		nIndex = m_lstBHO.InsertItem(0, lpszBHOName, nStateCode);
	}

	// Set text for list view columns
	m_lstBHO.SetItemText(nIndex, BHO_COLUMN_INFO, sInfo);
	m_lstBHO.SetItemText(nIndex, BHO_COLUMN_VERSION, sVersion);
	m_lstBHO.SetItemText(nIndex, BHO_COLUMN_PATH, sPath);
	m_lstBHO.SetItemText(nIndex, BHO_COLUMN_CLSID, lpszCLSID);
	m_lstBHO.SetItemData(nIndex, nStateCode);
}

BHO_CHECK_CODE CBHOCopDlg::CheckBHO(LPCTSTR lpszCLSID, CStringEx& sBHOObjectName, CStringEx& sInfo, CStringEx& sVersion, CStringEx& sPath)
{
	CRegKey			CLSIDkey;
	BHO_CHECK_CODE	retCode;
	CStringEx		sModuleName;
	DWORD			dwLen;

	CString	sCLSID = g_szCLSID;
	sCLSID += lpszCLSID;

	// Key exist?
	if (CLSIDkey.Open(HKEY_CLASSES_ROOT, sCLSID, KEY_READ) != ERROR_SUCCESS)
	{
		// Not registered
		sBHOObjectName = g_szUnknown;
		retCode = BHO_CHECK_BROKEN;
		sInfo.LoadString(IDS_INFO_NOTREGISTERED);
	}
	else
	{
		dwLen = MAX_PATH + 1;
		if (sBHOObjectName.IsEmpty())
		{
			// The default value for the BHO key doesn't contain any BHO name 
			CLSIDkey.QueryValue(sBHOObjectName.GetBuffer(MAX_PATH + 1), NULL, &dwLen);
			sBHOObjectName.ReleaseBuffer();
		}

		CLSIDkey.Close();

		BOOL bLocKeyOpened = CLSIDkey.Open(HKEY_CLASSES_ROOT, sCLSID + g_szLocationKey, KEY_READ) == ERROR_SUCCESS;

		if (!bLocKeyOpened)
		{
			// Failed - Maybe a "TreatAs" case?
			if (CLSIDkey.Open(HKEY_CLASSES_ROOT, sCLSID + g_szTreatAs, KEY_READ) == ERROR_SUCCESS)
			{
				// Yes - Search real CLSID
				CString	sTreatAsClsid;

				dwLen = MAX_CLSID_LEN;
				if (CLSIDkey.QueryValue(sTreatAsClsid.GetBuffer(MAX_CLSID_LEN), NULL, &dwLen) == ERROR_SUCCESS)
				{
					sTreatAsClsid.ReleaseBuffer();
					CLSIDkey.Close();

					sCLSID = g_szCLSID;
					sCLSID += sTreatAsClsid;
					bLocKeyOpened = CLSIDkey.Open(HKEY_CLASSES_ROOT, sCLSID + g_szLocationKey, KEY_READ) == ERROR_SUCCESS;
				}
				else
					CLSIDkey.Close();
			}
		}

		if (bLocKeyOpened)
		{
			// Now check for existence of implementation module
			dwLen = MAX_PATH;
			CLSIDkey.QueryValue(sModuleName.GetBuffer(MAX_PATH + 1), NULL, &dwLen);
			CLSIDkey.Close();
			sModuleName.ReleaseBuffer();

			WIN32_FIND_DATA FileInfo;
			HANDLE hFind = ::FindFirstFile(sModuleName, &FileInfo) ;
			BOOL bFileFound = hFind != INVALID_HANDLE_VALUE;

			// FindFirstFile may fail if module is stored in "Downloaded Program Files"
			if (bFileFound)
				FindClose(hFind);
			else
			{
				CFile	fModule;

				bFileFound = fModule.Open(sModuleName, CFile::modeRead);
				if (bFileFound)
					fModule.Close();
			}

			// Pass back module name anyway
			sPath = sModuleName;

			if (!bFileFound)
			{
				sInfo.LoadString(IDS_INFO_MODULENOTFOUND);
				retCode = BHO_CHECK_WARNING;
			}
			else
			{
				retCode = BHO_CHECK_OK;

				CVersion	ver;
				CStringEx	sDir;
				CString		sver;

				// Try to get VERSIONINFO for this file
				ver.CheckFile(sModuleName, TRUE, sDir.GetBuffer(MAX_PATH));
				sDir.ReleaseBuffer();

				TCHAR	szBinVersionInfo[MAX_VER_LEN];
				LPSTR	lpszInfo;

				if (ver.GetStatus())
				// VERSIONINFO found
				{
					// Get version string
					ver.GetTrueFileVersionString(szBinVersionInfo, sizeof(szBinVersionInfo) - 1);
					sVersion = szBinVersionInfo;
					if (sVersion.IsEmpty())
						sVersion.LoadString(IDS_INFO_NOVERSION);

					UINT nLen;
					// Get company name and comments
					ver.QueryValue(qvCompanyName, &lpszInfo, &nLen);
					sInfo = lpszInfo;
					ver.QueryValue(qvComments, &lpszInfo, &nLen);
					if (!sInfo.IsEmpty() && (lpszInfo[0] != _T('\0')))
						sInfo += _T("-");
					sInfo += lpszInfo;
				}
			}
		}
		else
		{
			// Not correctly registered
			retCode = BHO_CHECK_BROKEN;
			sInfo.LoadString(IDS_INFO_REGISTRATIONERROR);
		}
	}
	
	return retCode;
}

void CBHOCopDlg::OnDestroy() 
{
	// Close help file
	AfxGetApp()->WinHelp(0L, HELP_QUIT);

	// Save current config anyway
	SaveConfig(m_sLastConf);

	if (!m_bQuiet)
	{
		// Save window position, size and state
		WINDOWPLACEMENT WndStatus;
		
		WndStatus.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(&WndStatus);

		CString sOut;
		
		sOut.Format("%d", WndStatus.flags);
		WritePrivateProfileString(g_szPosSection, g_szFlagsEntry, sOut, m_sIniFilename);
		sOut.Format("%d", WndStatus.showCmd);
		WritePrivateProfileString(g_szPosSection, g_szShowEntry, sOut, m_sIniFilename);
		sOut.Format("%d", WndStatus.rcNormalPosition.left);
		WritePrivateProfileString(g_szPosSection, g_szLeftEntry, sOut, m_sIniFilename);
		sOut.Format("%d", WndStatus.rcNormalPosition.top);
		WritePrivateProfileString(g_szPosSection, g_szTopEntry, sOut, m_sIniFilename);
		sOut.Format("%d", WndStatus.rcNormalPosition.right);
		WritePrivateProfileString(g_szPosSection, g_szRightEntry, sOut, m_sIniFilename);
		sOut.Format("%d", WndStatus.rcNormalPosition.bottom);
		WritePrivateProfileString(g_szPosSection, g_szBottomEntry, sOut, m_sIniFilename);

		// Save column widths
		sOut.Format("%d", m_lstBHO.GetColumnWidth(0));
		WritePrivateProfileString(g_szPosSection, g_szColumn0, sOut, m_sIniFilename);
		sOut.Format("%d", m_lstBHO.GetColumnWidth(1));
		WritePrivateProfileString(g_szPosSection, g_szColumn1, sOut, m_sIniFilename);
		sOut.Format("%d", m_lstBHO.GetColumnWidth(2));
		WritePrivateProfileString(g_szPosSection, g_szColumn2, sOut, m_sIniFilename);
		sOut.Format("%d", m_lstBHO.GetColumnWidth(3));
		WritePrivateProfileString(g_szPosSection, g_szColumn3, sOut, m_sIniFilename);
		sOut.Format("%d", m_lstBHO.GetColumnWidth(4));
		WritePrivateProfileString(g_szPosSection, g_szColumn4, sOut, m_sIniFilename);
	}

	CDialog::OnDestroy();
	
	// Write current config name to bhocop.ini
	WritePrivateProfileString(g_szIniOptSection, g_szLastConf,  m_sLastConf, m_sIniFilename);

	// Now warn user if necesary
	if (m_bChanged)
	{
		BOOL bIsNT = m_OS == OS_WIN_NT || m_OS == OS_WIN_2000;

		BOOL bWduInstalled = TRUE;	// Assume WDU is present
		BOOL bWebView = FALSE;		// Assume no Web View

		CRegKey		WduKey;
		CRegKeyEx	WebViewKey;
		CStringEx	sModule;

		if (WduKey.Open(HKEY_LOCAL_MACHINE, g_szWduKey, KEY_READ) == ERROR_SUCCESS)
		{
			DWORD dwLen = MAX_PATH + 1;
			WduKey.QueryValue(sModule.GetBuffer(MAX_PATH + 1), NULL, &dwLen);
			sModule.ReleaseBuffer();
			WduKey.Close();
		}

		if (sModule.FindNoCase(_T("url.dll")) != -1)
			// WDU not installed
			bWduInstalled = FALSE;

		if (WebViewKey.Open(HKEY_CURRENT_USER, g_szActiveDesktopKey, KEY_READ) == ERROR_SUCCESS)
		{
			BYTE	cShellStateValue[29];
			DWORD	dwLen = 28;

			if (WebViewKey.QueryValue(cShellStateValue, g_szShellState, &dwLen) == ERROR_SUCCESS)
			{
				WebViewKey.Close();
				// If bit 6 is set in 4th byte of shellstate value,
				// the Web View option is ON.
				bWebView = (cShellStateValue[4] & 0x40) != 0;	
			}
		}

		// Any Windows Explorer or Internet Explorer window open?
		BOOL bIEWindow = FindWindow("IEFrame", NULL) != NULL;
		BOOL bExplorerWindow = FindWindow("ExploreWClass", NULL) != NULL;

		if (bWduInstalled && bWebView)
			AfxMessageBox(IDS_LOGOFF, MB_OK | MB_ICONINFORMATION, 0);
		else if (bWduInstalled && (bIEWindow || bExplorerWindow))
			AfxMessageBox(IDS_CLOSE_ALL, MB_OK | MB_ICONINFORMATION, 0);
		else if (!bWduInstalled	&& bIEWindow)
			AfxMessageBox(IDS_CLOSE_IE, MB_OK | MB_ICONINFORMATION, 0);
	}
}

BOOL CBHOCopDlg::LoadConfig(CString sConfigName)
{
	TCHAR szBuffer[2048];
	// Get list of entries
	GetPrivateProfileString(sConfigName, NULL, _T(""), szBuffer, sizeof(szBuffer), m_sIniFilename);
	
	TCHAR	szClsid[MAX_CLSID_LEN];
	TCHAR*	lpClsid = szBuffer;

	// For each entry, disable or re-enable BHO
	while (*lpClsid != (TCHAR) '\0')
	{
		_tcscpy(szClsid, lpClsid);
		lpClsid += _tcslen(szClsid) + 1;

		BOOL		bIsDisabled;
		CRegKey		BHOKey;
		CStringEx	sBHOName;
		BOOL		bEnable = (BOOL) GetPrivateProfileInt(sConfigName, szClsid, 1, m_sIniFilename);
		
		GetPrivateProfileString(g_szIniDisabledSection, szClsid, _T(""), sBHOName.GetBuffer(MAX_PATH), MAX_PATH, m_sIniFilename);
		sBHOName.ReleaseBuffer();
		bIsDisabled = !sBHOName.IsEmpty();

		if (bEnable && bIsDisabled) // BHO should be enabled if not already
		{
			CStringEx sInfo;	// dummy
			CStringEx sVersion; // dummy
			CStringEx sPath;	// dummy

			// If BHO was disabled and still valid, re-install BHO key 
			// and remove it from the [disabled] section
			if ((CheckBHO(szClsid, sBHOName, sInfo, sVersion, sPath) == BHO_CHECK_OK) 
				 && 
				 (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS))
			{
				BHOKey.SetKeyValue(szClsid, sBHOName);
				BHOKey.Close();
			}

			// Remove from the [disabled] section
			WritePrivateProfileString(g_szIniDisabledSection, szClsid, NULL, m_sIniFilename);
		}
		else if (!bEnable && !bIsDisabled)
		{
			int nIndex = -1;

			for (int i = 0; i < m_lstBHO.GetItemCount(); i++)
			{
				CString sCurClsid = m_lstBHO.GetItemText(i, BHO_COLUMN_CLSID);
				if (sCurClsid.CompareNoCase(szClsid) == 0)
				{
					nIndex = i;
					break;
				}
			}

			if (nIndex != -1)
			{
				// Add to the [disabled] section
				WritePrivateProfileString(g_szIniDisabledSection, szClsid, m_lstBHO.GetItemText(nIndex, BHO_COLUMN_NAME), m_sIniFilename);
				// Now delete BHO Key
				if (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS)
				{
					BHOKey.RecurseDeleteKey(szClsid);
					BHOKey.Close();
				}
			}
		}
	}

	m_sLastConf = sConfigName;
	GetDlgItem(IDC_CONFIGNAME)->SetWindowText(m_sLastConf);
	m_bChanged = TRUE;
	EnumBHOs();

	return TRUE;
}

void CBHOCopDlg::SaveConfig(CString sConfigName)
{
	int nIndex;

	// First destroy section
	WritePrivateProfileString(sConfigName, NULL, NULL, m_sIniFilename);

	// Save state of each checkbox
	for(nIndex = 0; nIndex < m_lstBHO.GetItemCount(); nIndex++)
	{
		CStringEx	sClsid;
		DWORD		nState = m_lstBHO.GetItemData(nIndex);

		if ((nState != BHO_STATE_WARNING) && (nState != BHO_STATE_BROKEN))
		{
			sClsid = m_lstBHO.GetItemText(nIndex, BHO_COLUMN_CLSID);
			WritePrivateProfileString(sConfigName, 
									  sClsid, 
									  m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED ? _T("1") : _T("0"), 
									  m_sIniFilename);
		}
	}

	// Store config name
	WritePrivateProfileString(g_szIniCfgSection, sConfigName, _T(""), m_sIniFilename);
	m_sLastConf = sConfigName;
	GetDlgItem(IDC_CONFIGNAME)->SetWindowText(m_sLastConf);
}

void CBHOCopDlg::OnFileSaveCfgAs() 
{
	CSaveConfigDlg dlg;
	
	dlg.m_sCurrentName = m_sLastConf;
	dlg.m_sIniFilename = m_sIniFilename;
	if ((dlg.DoModal() == IDOK) && (!dlg.m_sCurrentName.IsEmpty()))
	{
		m_sLastConf = dlg.m_sCurrentName;
		SaveConfig(m_sLastConf);
	}

	Invalidate();
}

void CBHOCopDlg::OnFileLoadCfg() 
{
	CLoadConfigDlg dlg;
	
	dlg.m_sCurrentName = m_sLastConf;
	dlg.m_sIniFilename = m_sIniFilename;
	if (dlg.DoModal() == IDOK)
	{
		m_sLastConf = dlg.m_sCurrentName;
		LoadConfig(m_sLastConf);
	}

	Invalidate();

	// Take possible new BHOs into account
	SaveConfig(m_sLastConf);
}

void CBHOCopDlg::OnFileExit() 
{
	EndDialog(IDCANCEL);
}

void CBHOCopDlg::OnItemEnable() 
{
	BOOL		bIsDisabled;
	CRegKey		BHOKey;
	CStringEx	sBHOName;
	CStringEx	sClsid;
	int			nIndex = -1;

	// Get index of selected item
	nIndex = m_lstBHO.GetNextItem(nIndex, LVNI_SELECTED);

	if (nIndex == -1)
		return;
	else
		m_nLastSel = nIndex;

	BOOL bEnable = m_lstBHO.GetItemData(nIndex) != BHO_STATE_ENABLED;
	
	sClsid = m_lstBHO.GetItemText(nIndex, BHO_COLUMN_CLSID);
	GetPrivateProfileString(g_szIniDisabledSection, sClsid, _T(""), sBHOName.GetBuffer(MAX_PATH), MAX_PATH, m_sIniFilename);
	sBHOName.ReleaseBuffer();
	bIsDisabled = !sBHOName.IsEmpty();

	if (bEnable && bIsDisabled) // BHO should be enabled if not already
	{
		CStringEx sInfo;	// dummy
		CStringEx sVersion; // dummy
		CStringEx sPath;	// dummy

		// If BHO was disabled and still valid, re-install BHO key
		// and remove it from the [disabled] section
		if ((CheckBHO(sClsid, sBHOName, sInfo, sVersion, sPath) == BHO_CHECK_OK) 
			 && 
			 (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS))
		{
			BHOKey.SetKeyValue(sClsid, sBHOName);
			BHOKey.Close();
		}

		// Remove from the [disabled] section
		WritePrivateProfileString(g_szIniDisabledSection, sClsid, NULL, m_sIniFilename);
	}
	else if (!bEnable && !bIsDisabled)
	{
		// Add to the [disabled] section
		WritePrivateProfileString(g_szIniDisabledSection, sClsid, m_lstBHO.GetItemText(nIndex, BHO_COLUMN_NAME), m_sIniFilename);
		// Now delete BHO Key
		if (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS)
		{
			BHOKey.RecurseDeleteKey(sClsid);
			BHOKey.Close();
		}
	}

	m_bChanged = TRUE;
	EnumBHOs();
	SaveConfig(m_sLastConf);
}

void CBHOCopDlg::OnUpdateItemEnable(CCmdUI* pCmdUI) 
{
	int nIndex = -1;

	nIndex = m_lstBHO.GetNextItem(nIndex, LVNI_SELECTED);

	if (nIndex != -1)
	{
		BOOL bEnabled = m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED;
		
		pCmdUI->Enable(m_bCanAccess && ((m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED) || (m_lstBHO.GetItemData(nIndex) == BHO_STATE_DISABLED)));
		pCmdUI->SetCheck(bEnabled? 1 : 0);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CBHOCopDlg::OnItemRemove() 
{
	CRegKey		BHOKey;
	CStringEx	sBHOName;
	CStringEx	sClsid;
	int			nIndex = -1;

	nIndex = m_lstBHO.GetNextItem(nIndex, LVNI_SELECTED);

	if (nIndex == -1)
		return;

	sClsid = m_lstBHO.GetItemText(nIndex, BHO_COLUMN_CLSID);

	if (BHOKey.Create(HKEY_LOCAL_MACHINE, g_szBHOKey) == ERROR_SUCCESS)
	{
		BHOKey.RecurseDeleteKey(sClsid);
		BHOKey.Close();

		// Remove from the [disabled] section
		WritePrivateProfileString(g_szIniDisabledSection, sClsid, NULL, m_sIniFilename);
	}

	m_bChanged = TRUE;
	EnumBHOs();
	SaveConfig(m_sLastConf);
}

void CBHOCopDlg::OnUpdateItemRemove(CCmdUI* pCmdUI) 
{
	int nIndex = -1;

	nIndex = m_lstBHO.GetNextItem(nIndex, LVNI_SELECTED);

	if (nIndex != -1)
		pCmdUI->Enable(m_bCanAccess && ((m_lstBHO.GetItemData(nIndex) == BHO_STATE_BROKEN) || (m_lstBHO.GetItemData(nIndex) == BHO_STATE_WARNING)));
	else
		pCmdUI->Enable(FALSE);
}

void CBHOCopDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	UINT uFlags = LVHT_ONITEMLABEL | LVHT_ONITEMICON | LVHT_ONITEMLABEL;

    pWnd->ScreenToClient(&point); 
	int nItem = m_lstBHO.HitTest(point, &uFlags);
	pWnd->ClientToScreen(&point);

	if (nItem != -1)
	{
		m_lstBHO.SetItem(nItem, 0, LVIF_STATE, NULL, 0, LVIS_SELECTED, LVIS_SELECTED, 0);

		CMenu	mnuMain;
		CMenu*	pmnuCtxt;

		mnuMain.LoadMenu(IDR_MENU);
		pmnuCtxt = mnuMain.GetSubMenu(2);
		pmnuCtxt->TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, this, NULL);
	}
}

void CBHOCopDlg::OnUpdateFileLoadCfg(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bCanAccess);
}

void CBHOCopDlg::OnUpdateFileSaveCfgAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bCanAccess);
}

void CBHOCopDlg::WinHelp(DWORD dwData, UINT nCmd) 
{
	if (nCmd == HELP_CONTEXT)
		nCmd = HELP_CONTENTS;
	CDialog::WinHelp(0, nCmd);
}

void CBHOCopDlg::StoreOsVersion()
{
	// Get OS version
	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

	if(!(bOsVersionInfoEx = GetVersionEx((OSVERSIONINFO *) &osvi)))
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) )
		{
		   m_OS = OS_WIN_NONE;
		   return;
		}
	}

	switch (osvi.dwPlatformId)
	{
		case VER_PLATFORM_WIN32_NT:
			if ( osvi.dwMajorVersion <= 4 )
				m_OS = OS_WIN_NT;

			if ( osvi.dwMajorVersion == 5 )
				m_OS = OS_WIN_2000;
			break;

		case VER_PLATFORM_WIN32_WINDOWS:
			if ((osvi.dwMajorVersion > 4) || ((osvi.dwMajorVersion == 4) && (osvi.dwMinorVersion > 0)))
				m_OS = OS_WIN_1998;
			else 
				m_OS = OS_WIN_1995;
			break;

		case VER_PLATFORM_WIN32s:
				m_OS = OS_WIN_32;
				break;

		default:
				m_OS = OS_WIN_NONE;
	}
}

void CBHOCopDlg::OnClickBhoList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Get the current mouse location and convert it to client
	// coordinates.
	DWORD pos = GetMessagePos();
	CPoint pt(LOWORD(pos), HIWORD(pos));
	m_lstBHO.ScreenToClient(&pt);

	int		nIndex;
	UINT	nHitFlags;
	CRect	rIcon;

	nIndex = m_lstBHO.HitTest(pt, &nHitFlags);

	if ((nIndex != -1) && (nHitFlags == LVHT_ONITEMICON))
	{
		BOOL bEnabled = m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED;
		
		if (m_bCanAccess && ((m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED) || (m_lstBHO.GetItemData(nIndex) == BHO_STATE_DISABLED)))
			OnItemEnable();
	}
		
	*pResult = 0;
}

void CBHOCopDlg::OnDblclkBhoList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Handle double-click
	int nIndex = -1;

	nIndex = m_lstBHO.GetNextItem(nIndex, LVNI_SELECTED);

	if (nIndex != -1)
	{
		BOOL bEnabled = m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED;
		
		if (m_bCanAccess && ((m_lstBHO.GetItemData(nIndex) == BHO_STATE_ENABLED) || (m_lstBHO.GetItemData(nIndex) == BHO_STATE_DISABLED)))
			OnItemEnable();
	}

	*pResult = 0;
}

void CBHOCopDlg::OnSize(UINT nType, int cx, int cy) 
{
	// Move all controls according to the new size
	if (m_bSizeInit && !m_bQuiet)
	{
		CRect	rectDialog;
		CRect	rectBHOList;
		CRect	rectConfLabel;
		CRect	rectConfName;
		CRect	rectExit;
		CRect	rectHelp;

		CWnd*	pwndBHOList = GetDlgItem(IDC_BHOLIST);
		CWnd*	pwndConfLabel = GetDlgItem(IDC_CONF_LABEL);
		CWnd*	pwndConfName = GetDlgItem(IDC_CONFIGNAME);
		CWnd*	pwndExit = GetDlgItem(IDOK);
		CWnd*	pwndHelp = GetDlgItem(ID_HELP);

		GetClientRect(rectDialog);

		pwndBHOList->GetWindowRect(rectBHOList);
		ScreenToClient(&rectBHOList);
		pwndConfLabel->GetWindowRect(rectConfLabel);
		ScreenToClient(&rectConfLabel);
		pwndConfName->GetWindowRect(rectConfName);
		ScreenToClient(&rectConfName);
		pwndExit->GetWindowRect(rectExit);
		ScreenToClient(&rectExit);
		pwndHelp->GetWindowRect(rectHelp);
		ScreenToClient(&rectHelp);

		HDWP hDwp = BeginDeferWindowPos(5);

		DeferWindowPos(hDwp,
					   pwndBHOList->m_hWnd, 
					   0, 
					   rectBHOList.left,
					   rectBHOList.top,
					   rectDialog.right - m_nListOffsetH - rectBHOList.left,
					   rectDialog.bottom - m_nListOffsetV - rectBHOList.top,
					   SWP_NOZORDER);

		DeferWindowPos(hDwp,
					   pwndConfLabel->m_hWnd, 
					   0, 
					   rectConfLabel.left,
					   rectDialog.bottom - m_nBottomOffsetConf,
					   rectConfLabel.Width(),
					   rectConfLabel.Height(),
					   SWP_NOZORDER);

		DeferWindowPos(hDwp,
					   pwndConfName->m_hWnd, 
					   0, 
					   rectConfName.left,
					   rectDialog.bottom - m_nBottomOffsetConf,
					   rectConfName.Width(),
					   rectConfName.Height(),
					   SWP_NOZORDER);

		DeferWindowPos(hDwp,
					   pwndExit->m_hWnd, 
					   0, 
					   rectDialog.right - m_nRightOffsetExit,
					   rectDialog.bottom - m_nBottomOffsetExit,
					   rectExit.Width(),
					   rectExit.Height(),
					   SWP_NOZORDER);

		DeferWindowPos(hDwp,
					   pwndHelp->m_hWnd, 
					   0, 
					   rectDialog.right - m_nRightOffsetHelp,
					   rectDialog.bottom - m_nBottomOffsetExit,
					   rectHelp.Width(),
					   rectHelp.Height(),
					   SWP_NOZORDER);

		EndDeferWindowPos(hDwp);

		CDialog::OnSize(nType, cx, cy);
	}
}

BOOL CBHOCopDlg::OnEraseBkgnd(CDC *pDC)
{
	// This trick provides flicker free resizing when the
	// "Display window contents when dragging" option is
	// ON in Explorer.
	if (m_bSizeInit && !m_bQuiet)
	{
		CRect	rectDialog;
		CRect	rectBHOList;
		CRect	rectConfLabel;
		CRect	rectConfName;
		CRect	rectExit;
		CRect	rectHelp;

		CWnd*	pwndBHOList = GetDlgItem(IDC_BHOLIST);
		CWnd*	pwndConfLabel = GetDlgItem(IDC_CONF_LABEL);
		CWnd*	pwndConfName = GetDlgItem(IDC_CONFIGNAME);
		CWnd*	pwndExit = GetDlgItem(IDOK);
		CWnd*	pwndHelp = GetDlgItem(ID_HELP);

		pwndBHOList->GetWindowRect(rectBHOList);
		ScreenToClient(&rectBHOList);
		pDC->ExcludeClipRect(rectBHOList);
		pwndConfLabel->GetWindowRect(rectConfLabel);
		ScreenToClient(&rectConfLabel);
		pDC->ExcludeClipRect(rectConfLabel);
		pwndConfName->GetWindowRect(rectConfName);
		ScreenToClient(&rectConfName);
		pDC->ExcludeClipRect(rectConfName);
		pwndExit->GetWindowRect(rectExit);
		ScreenToClient(&rectExit);
		pDC->ExcludeClipRect(rectExit);
		pwndHelp->GetWindowRect(rectHelp);
		ScreenToClient(&rectHelp);
		pDC->ExcludeClipRect(rectHelp);
	}

	CDialog::OnEraseBkgnd(pDC);

	return FALSE;
}

void CBHOCopDlg::OnGetMinMaxInfo(MINMAXINFO *lpMMI)
{
	// A minimum size is necessary to avoid display problems
	if(m_bSizeInit && !m_bQuiet)
	{
		lpMMI->ptMinTrackSize.x = MIN_FRAME_SIZEX;
		lpMMI->ptMinTrackSize.y = MIN_FRAME_SIZEY;
	}
}
