// BHOCOP Version 1.0
// Copyright (c) 2001 Ziff Davis Media, Inc.
// All rights reserved.
// First Published in PC Magazine, US Edition, May 22, 2001.
// Programmer: Patrick Philippot



/************************************************************
THIS PROGRAM IS USED BY THE BHO COP UNINSTALLATION PROCESS
DO NOT RUN IT SEPARATELY. THANKS.
************************************************************/


#include "stdafx.h"
#include "resource.h"
#include "tchar.h"


#define	MAX_CLSID_LEN		40

TCHAR g_szIniDisabledSection[] = _T("disabled");
TCHAR g_szBHOKey[] = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Browser Helper Objects\\");

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	TCHAR	szIniFilename[MAX_PATH];
	TCHAR	szAppPath[MAX_PATH];
	TCHAR*	pszEnd;
	TCHAR	szTitle[25];
	TCHAR	szPrompt[150];

	::LoadString(hInstance, IDS_BHOCOP_UNINSTALL, szTitle, sizeof(szTitle));

	if (strstr(lpCmdLine, _T("/restore")) == NULL)
	{
		::LoadString(hInstance, IDS_DONOTRUN, szPrompt, sizeof(szPrompt));
		::MessageBox(::GetFocus(), szPrompt, szTitle, MB_OK | MB_ICONEXCLAMATION);
		return (0);
	}

	GetModuleFileName(hInstance, szIniFilename, MAX_PATH);
	// Now enumerate disabled BHOs from the [disabled] section of bhocop.ini

	pszEnd = _tcsrchr(szIniFilename, '\\');
	if (pszEnd != NULL)
		*(pszEnd + 1) = TCHAR('\0');

	_tcscpy(szAppPath, szIniFilename);
	_tcscat(szIniFilename, _T("bhocop.ini"));

	TCHAR szBuffer[2048];

	// Get list of entries
	GetPrivateProfileString(g_szIniDisabledSection, NULL, _T(""), szBuffer, sizeof(szBuffer), szIniFilename);
	
	TCHAR	szClsid[MAX_CLSID_LEN];
	TCHAR	szBHOName[MAX_PATH + 1];
	TCHAR*	lpClsid = szBuffer;

	HKEY hBHOKey;

	if (RegOpenKey(HKEY_LOCAL_MACHINE, g_szBHOKey, &hBHOKey) == ERROR_SUCCESS)
	{
		while (*lpClsid != (TCHAR) '\0')
		{
			_tcscpy(szClsid, lpClsid);
			lpClsid += _tcslen(szClsid) + 1;

			GetPrivateProfileString(g_szIniDisabledSection, szClsid, _T(""), szBHOName, sizeof(szBHOName), szIniFilename);
			RegSetValue(hBHOKey, szClsid, REG_SZ, szBHOName, _tcslen(szBHOName));
		}

		RegCloseKey(hBHOKey);

		::LoadString(hInstance, IDS_RESTORED_PROMPT, szPrompt, sizeof(szPrompt));
		::MessageBox(::GetFocus(), szPrompt, szTitle, MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		::LoadString(hInstance, IDS_FAILED_PROMPT, szPrompt, sizeof(szPrompt));
		::MessageBox(::GetFocus(), szPrompt, szTitle, MB_OK | MB_ICONEXCLAMATION);
	}

	_tcscpy(szIniFilename, szAppPath);
	_tcscat(szIniFilename, _T("rescue.bak"));
	SetFileAttributes(szIniFilename, FILE_ATTRIBUTE_NORMAL);
	DeleteFile(szIniFilename);
	_tcscpy(szIniFilename, szAppPath);
	_tcscat(szIniFilename, _T("rescue.reg"));
	DeleteFile(szIniFilename);

	return 0;
}



